/*
Copyright (C) 2013 Haowen Ning

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/
package org.liberty.android.fantastischmemo.aspect;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

@Target(ElementType.METHOD)
@Retention(RetentionPolicy.RUNTIME)

/*
 * The method with this annotation will be checking null arguments first.
 * If any of the argumetns are null, the method execution will be
 * either ignored or throw exception.
 */
public @interface CheckNullArgs {
    /*
     * If throw is true, the method will throw NullPointerException.
     * Otherwise the annoated method will return silently.
     */
    boolean throwException() default false;

    /*
     * Only check the index specified for null.
     */
    int[] argIndexToCheck() default {};
}

